	.include	"global.inc"

	;; BANKED:	checked
	.area	_BASE

	;; Wait until all buttons have been released
;.padup::
;_waitpadup::
;	PUSH	AF		; Save modified registers
;	PUSH	BC
;1$:
;	LD	B,#0xFF
;2$:
;	CALL	.jpad
;	OR	A		; Have all buttons been released?
;	JR	NZ,1$		; Not yet

;	DEC	B
;	JR	NZ,2$
;	POP	BC		; Restore registers
;	POP	AF
;	RET

	;; Get Keypad Button Status
	;; The following bits are set if pressed:
	;;   0x80 - Start   0x08 - Down
	;;   0x40 - Select  0x04 - Up
	;;   0x20 - B	    0x02 - Left
	;;   0x10 - A	    0x01 - Right
.jpad::
	PUSH	BC		; Save modified registers
	LD	A,#0x20
	LDH	(.P1),A		; Turn on P15

	LDH	A,(.P1)		; Delay
	LDH	A,(.P1)
	CPL
	AND	#0x0F
	SWAP	A
	LD	B,A
	LD	A,#0x10
	LDH	(.P1),A		; Turn on P14
	LDH	A,(.P1)		; Delay
	LDH	A,(.P1)
	LDH	A,(.P1)
	LDH	A,(.P1)
	LDH	A,(.P1)
	LDH	A,(.P1)
	CPL
	AND	#0x0F
	OR	B
	SWAP	A
	LD	B,A
	LD	A,#0x30
	LDH	(.P1),A		; Turn off P14 and P15 (reset joypad)
	LD	A,B
	POP	BC		; Restore registers
	RET

	;; Wait for the key in B to be pressed
;.wait_pad::
;1$:
;	CALL	.jpad		; Read pad
;	AND	B		; Compare with mask?
;	JR	Z,1$		; Loop if no intersection
;	RET

;;unsigned char joy_read(unsigned char n)
_joy_read::
;;_joypad::
	CALL	.jpad
	ld  d,#0
	LD	E,A		; Return result in DE
	RET

;;unsigned char joy_count(void)
_joy_count::
	LD	E,#1		; Return result in DE
	RET

;;unsigned char joy_load_driver(char *name)
_joy_load_driver::
	;;return JOY_ERR_OK;
	LD	E,#0 	; Return result in DE
	RET

;;const unsigned char *joy_stddrv=NULL;
_joy_stddrv::
		.word 0
;;const unsigned char joy_masks[8]=
_joy_masks::
	.db #0x02;J_LEFT,    //0x02U
	.db #0x01;J_RIGHT,   //0x01U
	.db #0x04;J_UP,      //0x04U
	.db #0x08;J_DOWN,    //0x08U
	.db #0x10;J_A,       //0x10U
	.db #0x20;J_B,       //0x20U
	.db #0x80;J_START,   //0x80U
	.db #0x40;J_SELECT   //0x40U

;_waitpad::
;	PUSH	BC
;	LDA	HL,4(SP)	; Skip return address and registers
;	LD	B,(HL)
;	CALL	.wait_pad
;	LD	E,A		; Return result in DE
;	POP	BC
;	RET
