
#include "conio.h"

#define SCREEN_X	40
#define SCREEN_Y	30

static unsigned char  conscreen[SCREEN_X][SCREEN_Y];
static   signed short concolor [SCREEN_X][SCREEN_Y];
static   signed short conbcolor[SCREEN_X][SCREEN_Y];
static int curx,cury;
static int tcol,bcol,trev;

//typedef u8 Screen[GPC_LCD_WIDTH][GPC_LCD_HEIGHT];
//Screen *screen,*screen0;
//GPDRAWSURFACE gpDrawSurfaces[2]={{0},{0}};
//int gpDrawSurfaceIndex=0;
GPDRAWSURFACE gpDrawSurfaces[2]={{0},{0}};
int gpDrawSurfaceIndex=0;
//GPDRAWSURFACE *gpDrawSurface;
//static unsigned char *scrn;

void clrscr(void){
int i;
	// clear screen buffer;
	for(i=0;i<(40*30);i++){
		((unsigned char*)(&conscreen[0][0]))[i]=' ';
	}
	for(i=0;i<(40*30);i++){
		((signed short*)(&concolor[0][0]))[i]=tcol;
	}
	for(i=0;i<(40*30);i++){
		((signed short*)(&conbcolor[0][0]))[i]=bcol;
	}
	curx=cury=0;
}

const unsigned char palette_red[16] = {
	0x00, 0xff, 0x68, 0x70, 0x6f, 0x58, 0x35, 0xb8, 0x6f, 0x43, 0x9a, 0x44, 0x6c, 0x9a, 0x6c, 0x95
};
const unsigned char palette_green[16] = {
	0x00, 0xff, 0x27, 0xa4, 0x3d, 0x8d, 0x28, 0xc7, 0x4f, 0x39, 0x67, 0x44, 0x6c, 0xd2, 0x5e, 0x95
};
const unsigned char palette_blue[16] = {
	0x00, 0xff, 0x2b, 0xb2, 0x86, 0x43, 0x79, 0x6f, 0x25, 0x00, 0x59, 0x44, 0x6c, 0x84, 0xb5, 0x95
};

unsigned long palette[0x100];

void conio_init(void) {
int i;
//static unsigned long __align32__ palette[0x100];
unsigned long  r,g,b;

		tcol=0xff;bcol=0;trev=0;
		clrscr();

        // Initialize (get an address where the screen buffer should be located at)

		GpSurfaceSet=(tGpSurfaceSet)Init();

//        GpSurfaceSet=(void*)(GPDRAWSURFACE*)Init();
//        GpSurfaceSet=(void)()Init();
        GpSurfaceFlip=GpSurfaceSet;

        // palette color mode
        GpGraphicModeSet(GPC_DFLAG_8BPP, NULL);

	// get two surfaces
    for (i=0; i<2; i++)
	{
		GpLcdSurfaceGet(&gpDrawSurfaces[i], i);
	}

    // clear both buffers
	gpDrawSurfaceIndex=0;
    memset((u8*)gpDrawSurfaces[gpDrawSurfaceIndex].ptbuffer, 0, (GPC_LCD_WIDTH*GPC_LCD_HEIGHT));
    memset((u8*)gpDrawSurfaces[gpDrawSurfaceIndex^1].ptbuffer, 0, (GPC_LCD_WIDTH*GPC_LCD_HEIGHT));

	// show other buffer
	GpSurfaceSet(&gpDrawSurfaces[gpDrawSurfaceIndex^1]);

		for(i=0;i<16;i++){
			r=(palette_red[i]+4);if(r>0xff)r=0xff;
			g=(palette_green[i]+4);if(g>0xff)g=0xff;
			b=(palette_blue[i]+4);if(b>0xff)b=0xff;
			r=(r>>3)<<11;g=(g>>3)<<6;b=(b>>3)<<1;
			palette[i]=r|g|b|1;
		}
		for(i=16;i<256;i++){
			palette[i]=palette[i&0xf];
		}


		GpPaletteSet(&palette[0]);


	// enable display
	GpLcdEnable();

	//dateConio();
	conio_update();

}

extern const unsigned char _binary_font8x8_bin_start[];
extern const unsigned char _binary_gp32_font8x8_bin_start[];

// blit transparent char
static void blitchar(int chr,int x,int y,int col,int bcol){
unsigned char *c;
unsigned char *s;
int i,ii;
		// offset on screen
//		s=(unsigned char*)gpDrawSurface->ptbuffer;
		s=(u8*)gpDrawSurfaces[gpDrawSurfaceIndex].ptbuffer;
		s+=231-(y*8)+(x*240*8);

		// offset in charset
		chr*=(8*8);
 // 		c=(unsigned char*)((((unsigned long)&_binary_gp32_font8x8_bin_start[chr])+0));
  		c=(unsigned char*)((((unsigned long)&_binary_font8x8_bin_start[chr])+0));
//		c+=(chr*(8*8));

		if(bcol==-1) { // blit transparent ?

//			if(!isgraph(chr)) return;

			for(i=0;i<8;i++) {
				for(ii=0;ii<8;ii++){
	//				if(*c==0xff) *s=*c;
					if(*c==0xff) *s=col;
					c++;
					s++;
				}
           		s+=(240-8);
			}

		} else {	// blit solid

			for(i=0;i<8;i++) {
				for(ii=0;ii<8;ii++){
	//				if(*c==0xff) *s=*c;
					if(*c==0xff) *s=col;
					else *s=bcol;
					c++;
					s++;
				}
           		s+=(240-8);
			}

		}
//		return;
}

static void putchar(int c)
{
unsigned char *d;
unsigned char *s;
int x,y,co,bo;

	switch(c){
		case '\n':
			curx=0;
			cury++;
			break;
		default:
			conscreen[curx][cury]=c;
			if(trev)
			{
				concolor[curx][cury]=bcol;
				conbcolor[curx][cury]=tcol;
			}
			else
			{
				concolor[curx][cury]=tcol;
				conbcolor[curx][cury]=bcol;
			}

			curx++;
			break;
	}

	if(curx>39){ // end of line
		curx=0;
		cury++;
	}

	#if 0
	if(cury>29){ // last line

		s=(u8*)gpDrawSurfaces[gpDrawSurfaceIndex].ptbuffer;
		d=s+239;
		s=d-8;
		for(x=0;x<320;x++){
			for(y=0;y<(239-8);y++){
				d[y]=s[y];
			}
			s+=240;
			d+=240;
		}

		// scroll up one line
		cury=29;
		for(x=0;x<40;x++){
			for(y=0;y<29;y++){
				bo=conbcolor[x][y+1];
				conbcolor[x][y]=bo;
				co=concolor[x][y+1];
				concolor[x][y]=co;
				c=conscreen[x][y+1];
				conscreen[x][y]=c;
				blitchar(c,x,y,co,bo);
//				blitchar2(c,x,y);
			}
		}
		for(x=0;x<40;x++){
			conscreen[x][y]=' ';
			concolor[x][y]=tcol;
			conbcolor[x][y]=bcol;
			blitchar(' ',x,y,tcol,bcol);
//			blitchar2(' ',x,y);
		}
	}
	#endif // noscroll
}

void conio_update(void)
{
int x,y;
int ch,co,bo;
		for(x=0;x<40;x++){
			for(y=0;y<30;y++){
				ch=conscreen[x][y]; // charcode
				bo=conbcolor[x][y]; // bgcolor
				if(! ( (bo==-1) & (!isgraph(ch)) ) ){
					co=concolor[x][y]; // charcolor
					blitchar(ch,x,y,co,bo);
//					blitchar(x,x,y,0,0xff);
				}
			}
		}

	// show other buffer
	GpSurfaceSet(&gpDrawSurfaces[gpDrawSurfaceIndex]);
	gpDrawSurfaceIndex^=1;
}

void gotoxy(int x,int y){
	curx=x;cury=y;
}
int wherex(void){
	return(curx);
}
int wherey(void){
	return(cury);
}

void cputc(const char c)
{
	putchar(c);
//	UpdateConio();
}

void cputs(const char *s){
	while(*s!=0){
		putchar(*s);s++;
	}
//	UpdateConio();
}

void cvline (int length)
{
	int x=wherex();
	int y=wherey();
	while(length--)
	{
		gotoxy(x,y);
		putchar(CH_VLINE);
		y++;
	}
}

void chline (int length){
	while(length--) putchar(CH_HLINE);
}
void cclear (int length){
			while(length--) cputc(' ');
}


void chlinexy(unsigned char x,unsigned char y,char c)
{
	gotoxy(x,y);
	chline(c);
}
void cvlinexy(unsigned char x,unsigned char y,char c)
{
	gotoxy(x,y);
	cvline(c);
}
void cputcxy(unsigned char x,unsigned char y,char c)
{
	gotoxy(x,y);
	cputc(c);
}
void cputsxy(unsigned char x,unsigned char y,char *s)
{
	gotoxy(x,y);
	cputs(s);
}
void cclearxy(unsigned char x,unsigned char y,char c)
{
	gotoxy(x,y);
	cclear(c);
}


void cprintf(char *format,...) {
va_list args;
static char string[0x100];
//char *string;

//        string=(char*)malloc(0x100);

        va_start(args,format);
        vsprintf((char*)string,(char*)format,(va_list)args);
        va_end(args);
		cputs(string);

//        free(string);

}

int textcolor(int col){
int c;
	c=tcol;
	tcol=col;
	return(c);
}
int bgcolor(int col){
int c;
	c=bcol;
	bcol=col;
	return(c);
}

int revers(int col){
int c;
	c=trev;
	trev=col;
	return(c);
}
int bordercolor(int col)
{
	col=col;
	return 0;
}

void screensize(unsigned char *x,unsigned char *y)
{
	*x=SCREEN_X;*y=SCREEN_Y;
}


#if 0

void cmsgbox(char *text){
int lcnt,ccnt,i,c,x,y,w,h;

	// findout size of window
	lcnt=0;ccnt=0;c=0;
	i=0;while(text[i]!=0){
		if(text[i]=='\n'){
		 	lcnt++;
			c=0;
		} else {
			c++;if(c>ccnt) ccnt=c;
		}
		i++;
	}
	w=1+ccnt+1;h=1+lcnt+1;
	x=((320/8)/2)-(w/2);y=((240/8)/2)-(h/2);

	// save screen

	// print window
	gotoxy(x,y);

	ccnt=0;while(ccnt<(w)) {
		cputc('-'); ccnt++;
	};

	ccnt=0;i=0;c=1;
	gotoxy(x,y+c); cputc(' ');
	while(text[i]!=0){
		if(text[i]=='\n'){
			while(ccnt<(w-1)) {
				cputc(' '); ccnt++;
			}
			c++;ccnt=0;
			gotoxy(x,y+c); cputc(' ');
		} else {
			cputc(text[i]);
			ccnt++;
		}
		i++;
	}

	while(ccnt<(w)) {
		cputc(' '); ccnt++;
	}

	gotoxy(x,y+c+1);
	ccnt=0;while(ccnt<(w)) {
		cputc('-'); ccnt++;
	};

    while((GpKeyGet())!=0){};
    while((GpKeyGet())==0){
		UpdateConio();
    	// flip surface
		GpSurfaceFlip(&gpDrawSurfaces[gpDrawSurfaceIndex]);
		gpDrawSurfaceIndex ^= 1;
	};

	// restore screen

}

int clistbox(CLIST *list){
CLISTITEM *itm,*nitm;
int p,i,ii,s;
int tcol,bcol;
int key;
int x,y,w,h;
int ly,lh;
int delay;
int running=1;
int ret;
int slimit,plimit,first=1;

//	p=0;
//	s=0;
	s=list->soffs;
	p=list->ioffs;
	x=list->x;
	y=list->y;
	w=list->w;
	h=list->h;

	// actual list size
	ly=y;lh=h;

	// get current colors
	tcol=textcolor(0);textcolor(tcol);
	bcol=bgcolor(0);bgcolor(bcol);

	// print head
	gotoxy(x,y+0);chline(w);
	gotoxy(x,y+1);cputs(list->top);
	cclear((w+x)-wherex());
	gotoxy(x,y+2);chline(w);
	ly+=3;lh-=3;

	// print foot
	gotoxy(x,y+h-3);chline(w);
	gotoxy(x,y+h-2);cputs(list->bottom);
	cclear((w+x)-wherex());
	gotoxy(x,y+h-1);chline(w);
	lh-=3;

	slimit=list->items-lh;
	if(slimit<0) slimit=0;

	if(list->items<lh) plimit=list->items;
	else plimit=lh;

	// main loop
    while(running) {

		// scan to first item to be displayed
		itm=list->first;
		for(i=0;i<list->items;i++){
			if(i==s) break;
			if(itm==NULL) break;
			itm=itm->next;
		}

		// print the list
		for(i=0;i<lh;i++){

			gotoxy(x,ly+i);

			// make currently selected item inverse
			// and remember pointer
			if(p==i) {
				textcolor(bcol);bgcolor(tcol);
				nitm=itm;
			}

//			itm=nitm;

			if(itm!=NULL){
				// print item
				cputs(itm->text);
				// print option
				if(itm->numopt!=0){
//					cputc(':');
					cputs(itm->opt[itm->valopt]);
//					cprintf(" %d %d",itm->valopt,itm->numopt);
				}
				itm=itm->next;
			}
//			else {
//				cputs("empty");
//			}
			// clear rest of line
			cclear((w+x)-wherex());

//			cputc('\n');
			if(p==i) {
				textcolor(tcol);bgcolor(bcol);
			}
		}

		// update screen
		UpdateConio();
    	// flip surface
		GpSurfaceFlip(&gpDrawSurfaces[gpDrawSurfaceIndex]);
		gpDrawSurfaceIndex ^= 1;

		if(first){
			// wait for all keys released
			while(cgetc()!=0){};
			first--;
		}

		// handle keys

		key=cgetc();
		if(key==0) delay=0;
		else delay++;

		if((delay%10)==1) {

			switch(key) {
				// scroll
				case GPC_VK_UP:
					p--;
					break;
				case GPC_VK_DOWN:
					p++;
					break;
				// toggle value
				case GPC_VK_LEFT:
					if(nitm->valopt>0) nitm->valopt--;
					break;
				case GPC_VK_RIGHT:
					nitm->valopt++;
					if(nitm->valopt==nitm->numopt) nitm->valopt--;
					break;
				// select item
				case GPC_VK_SELECT:
				case GPC_VK_FA:
					// cycle items that have an option
					if(nitm->numopt>0){
						nitm->valopt++;
						if(nitm->valopt==nitm->numopt) nitm->valopt=0;
					} else {
						running=0;
//						ret=(p+s);
						ret=nitm->tag;
					}
					break;
				// abort
				case GPC_VK_START:
				case GPC_VK_FB:
					running=0;
					ret=-1;
					break;
			}

			if(p<0) {
				p=0;
				s--;
			}
			if(p==plimit) {
	//			p=(h-1);
				p--;
				s++;
			}

			if(s<0) s=0;
			if(s>slimit) s--;

		}

	}

	list->soffs=s;
	list->ioffs=p;

	// restore screen

//	return(p+s);
	return(ret);

}

#endif
