
#include "gp32.h"

const unsigned char *joy_stddrv="";


/*
#define	GPC_VK_LEFT		0x01
#define	GPC_VK_RIGHT	0x04
#define	GPC_VK_UP		0x08
#define	GPC_VK_DOWN		0x02

#define GPC_VK_F3		0x20
#define GPC_VK_ENTER	0x40
#define GPC_VK_START	0x100
#define GPC_VK_SELECT	0x200

#define GPC_VK_F1		0x80	// r
#define GPC_VK_F2		0x10	// l
*/

const unsigned char joy_masks[8]=
{
       	1,    //J_LEFT,    //0x02U
       	4,    //J_RIGHT,   //0x01U
       	8,    //J_UP,      //0x04U
       	2,    //J_DOWN,    //0x08U
        0x20, //J_A,       //0x10U
       	0x40, //J_B,       //0x20U
       	0x80, //J_START,   //0x80U
       	0x10, //J_SELECT   //0x40U
};

unsigned char joy_load_driver(const char *name)
{
	name=name; /* get rid of warning */

	GpKeyInit();
	return JOY_ERR_OK;
}

unsigned char joy_count(void)
{
	return (1);
}

unsigned char joy_read(unsigned char n)
{
int c=GpKeyGet();
	if(c<0x100)
	{
		return(c);
	}
	else
	{
		switch(c)
		{
			case 0x100:
				return 0x80;
			break;
			case 0x200:
				return 0x10;
			break;
		}
	}
	n=n;       /* get rid of warning */
	return(0);
}
