
#ifndef __JOYSTICK_H__
#define __JOYSTICK_H__

#include "gp32.h"

#define JOY_ERR_OK  0

#define JOY_LEFT	0
#define JOY_RIGHT   1
#define JOY_UP      2
#define JOY_DOWN    3

#define JOY_FIRE    4
#define JOY_FIRE_B  5
#define JOY_START   6
#define JOY_SELECT  7

/*
#define	GPC_VK_LEFT		0x01
#define	GPC_VK_RIGHT	0x04
#define	GPC_VK_UP		0x08
#define	GPC_VK_DOWN		0x02

#define GPC_VK_F3		0x20
#define GPC_VK_ENTER	0x40
#define GPC_VK_START	0x100
#define GPC_VK_SELECT	0x200

#define GPC_VK_F1		0x80	// r
#define GPC_VK_F2		0x10	// l
*/

extern const unsigned char *joy_stddrv;
extern const unsigned char joy_masks[8];

unsigned char joy_load_driver(const char *name);
unsigned char joy_count(void);
unsigned char joy_read(unsigned char n);

#endif // __JOYSTICK_H_

