MEMORY {
    ZP: start = $02, size = $1A, type = rw, define = yes;
    RAM: start = $7FF, size = $c801, define = yes, file = %O, fill=yes;
    HIRAM: start = $d000, size = $2000, define = yes, file = %O;
}
SEGMENTS {
    STARTUP: load = RAM, type = wprot;
    LOWCODE: load = RAM, type = wprot;
    CODE: load = RAM, type = wprot;
    RODATA: load = RAM, type = wprot;
    DATA: load = RAM, type = rw;
    BSS: load = RAM, type = bss, define = yes;
    ZEROPAGE: load = ZP, type = zp;
    HIRAM: load = HIRAM, type = wprot;
}
FEATURES {
    CONDES: segment = RODATA,
	    type = constructor,
	    label = __CONSTRUCTOR_TABLE__,
	    count = __CONSTRUCTOR_COUNT__;
    CONDES: segment = RODATA,
	    type = destructor,
	    label = __DESTRUCTOR_TABLE__,
	    count = __DESTRUCTOR_COUNT__;
}
SYMBOLS {
    __STACKSIZE__ = $800;	# 2K stack
}


