
.if .defined(___C64__)
	.include "c64/c64.inc"
.elseif .defined(___VIC20__)
	.include "vic20/vic20.inc"
.elseif .defined(___C16__)
	.include "plus4/plus4.inc"
.elseif .defined(___PLUS4__)
	.include "plus4/plus4.inc"
.elseif .defined(___PET__)
	.include "pet/pet.inc"
.elseif .defined(___CBM510__)
	.include "cbm510/cbm510.inc"
.elseif .defined(___CBM610__)
	.include "cbm610/cbm610.inc"
.else
	.error "unknown cbm system."
.endif

CH_HLINE    	=	 96
CH_VLINE    	=	125
CH_ULCORNER 	=	176
CH_URCORNER 	=	174
CH_LLCORNER 	=	173
CH_LRCORNER 	=	189
CH_TTEE	    	=	178
CH_RTEE	    	=	179
CH_BTEE	    	=	177
CH_LTEE	    	=	171
CH_CROSS    	=	123
CH_CURS_UP		=	145
CH_CURS_DOWN	=	 17
CH_CURS_LEFT	=	157
CH_CURS_RIGHT	=	 29
CH_PI			=	126
CH_DEL			=	20
CH_INS			=	148
CH_ENTER        =   10  
CH_STOP         =    3
CH_ESC          =    27
