
#ifndef __JOYSTICK_H__
#define __JOYSTICK_H__

#include "gb.h"

#define JOY_ERR_OK  0

#define JOY_LEFT	0
#define JOY_RIGHT   1
#define JOY_UP      2
#define JOY_DOWN    3

#define JOY_FIRE    4
#define JOY_FIRE_B  5
#define JOY_START   6
#define JOY_SELECT  7

extern const unsigned char *joy_stddrv;
extern const unsigned char joy_masks[8];

unsigned char joy_load_driver(char *name);
unsigned char joy_count(void);
unsigned char joy_read(unsigned char n);

#endif // __JOYSTICK_H_

