
#include "gba.h"
#include "joystick.h"

const unsigned char *joy_stddrv="";


/*
#define L_KEY                   0x0020      // Left Button
#define R_KEY                   0x0010      // Right Button
#define U_KEY                   0x0040      // Up Button
#define D_KEY                   0x0080      // Down Button

#define A_KEY                   0x0001      // A Button
#define B_KEY                   0x0002      // B Button
#define START_KEY               0x0008      // Start Button
#define SELECT_KEY              0x0004      // Select Button
*/

const unsigned char joy_masks[8]=
{
       	0x20,    //J_LEFT,    //0x02U
       	0x10,    //J_RIGHT,   //0x01U
       	0x40,    //J_UP,      //0x04U
       	0x80,    //J_DOWN,    //0x08U
        0x01, //J_A,       //0x10U
       	0x02, //J_B,       //0x20U
       	0x08, //J_START,   //0x80U
       	0x04, //J_SELECT   //0x40U
};

unsigned char joy_load_driver(const char *name)
{
	name=name; /* get rid of warning */

	return JOY_ERR_OK;
}

unsigned char joy_count(void)
{
	return (1);
}

unsigned char joy_read(unsigned char n)
{
unsigned short c = (*(volatile unsigned short*)REG_KEYINPUT ^ 0xffff);

	n=n;       /* get rid of warning */
	return(c);
}

