#ifndef __JOYSTICK_H__
#define __JOYSTICK_H__

#include "gba.h"

#define JOY_ERR_OK  0

#define JOY_LEFT	0
#define JOY_RIGHT   1
#define JOY_UP      2
#define JOY_DOWN    3

#define JOY_FIRE    4
#define JOY_FIRE_B  5
#define JOY_START   6
#define JOY_SELECT  7

/*
#define L_KEY                   0x0020      // Left Button
#define R_KEY                   0x0010      // Right Button
#define U_KEY                   0x0040      // Up Button
#define D_KEY                   0x0080      // Down Button

#define A_KEY                   0x0001      // A Button
#define B_KEY                   0x0002      // B Button
#define START_KEY               0x0008      // Start Button
#define SELECT_KEY              0x0004      // Select Button
*/

extern const unsigned char *joy_stddrv;
extern const unsigned char joy_masks[8];

unsigned char joy_load_driver(const char *name);
unsigned char joy_count(void);
unsigned char joy_read(unsigned char n);

#endif // __JOYSTICK_H_


