
extern const signed long sin_cos_table[256+64+256];

#define sin_table (&sin_cos_table[0])
#define cos_table (&sin_cos_table[64])

#define rsin(_a) (sin_table[(_a)&0xff])
#define rcos(_a) (cos_table[(_a)&0xff])

#define rpow(_x,_y)     ((_x)**(_y))
#define rpow2(_x)        ((2)**(_x))
#define rpow10(_x)      ((10)**(_x))

int rabs(int n);

