;
; Ullrich von Bassewitz, 03.06.1998
;
; Heap variables and initialization.
;

; FIXME: there should be a way to configure heap from linkerscript!

 		.import	__RAM_START__, __RAM_SIZE__, __STACKSIZE__	; Linker generated
		.import __BSS_SIZE__
		.import __DATA_SIZE__
		.importzp	sp

.data

		.export __heaporg
		.export __heapptr
		.export __heapend
		.export __heapfirst
		.export __heaplast

__heaporg:
       	.word  	__RAM_START__+__BSS_SIZE__+__DATA_SIZE__	; Linker calculates this symbol
__heapptr:
       	.word  	__RAM_START__+__BSS_SIZE__+__DATA_SIZE__	; Linker calculates this symbol
__heapend:
       	.word	__RAM_START__+__RAM_SIZE__
__heapfirst:
      	.word	0
__heaplast:
      	.word	0

; Initialization. Will be called from startup!

.code

      	.constructor	initheap, 24

initheap:
   	;sec

   	;lda	sp
;	lda	#<(__STACKSIZE__)
	lda #<(__RAM_START__+__RAM_SIZE__)
	sta	__heapend
;	lda	sp+1
;	lda	#>(__STACKSIZE__)
	lda #>(__RAM_START__+__RAM_SIZE__)
	sta	__heapend+1
	rts

