
#include "spectrum.h"
//#include <stdio.h>
//#include <stdarg.h>

#define SCREENX	32
#define SCREENY 24

/*
extern int __LIB__ getk();
#define getkey() fgetc_cons()
extern void __LIB__ puts_cons();
extern void __LIB__ printk(char *fmt,...);
*/

void gotoxy(unsigned char x,unsigned char y);
unsigned char wherex(void);
unsigned char wherey(void);
extern void cputs(char *s);

unsigned char cx,cy;

unsigned char cgetc(void)
{
	int k;
	k=getk();
	return k;
}
unsigned char kbhit(void)
{
}

void clrscr(void)
{
	#ifdef USEANSI
	#else
    printk("%c",12);
    printk("%c%c",1,32);
	#endif
	gotoxy(0,0);
}
void cputc(unsigned char c)
{
	char b[2];
	b[0]=c;b[1]=0;
	cputs(b);
}
void cputcxy(unsigned char x,unsigned char y,unsigned char c)
{
	gotoxy(x,y);
	cputc(c);
}
#if 0
void cputs(unsigned char *s)
{
	printk(s);
}
#endif

void cputsxy(unsigned char x,unsigned char y,unsigned char *s)
{
	gotoxy(x,y);
	cputs(s);
}

#if 1

extern int _vsprintf(char *string,char *format,va_list param);

static char string[0x100];
void cprintf(char *format,...)
{
va_list args;
//static char string[0x100];
        va_start(args,format);
        _vsprintf((char*)string,(char*)format,(va_list)args);
        va_end(args);
		cputs(string);
		//cputs(format);

}
#endif

void cvline(unsigned char c)
{
	unsigned char x=wherex();
	unsigned char y=wherey();
	while(c)
	{
		cputc('!');
		gotoxy(x,y);
		++y;--c;
	}
}
void cvlinexy(unsigned char x,unsigned char y,unsigned char c)
{
	gotoxy(x,y);
	cvline(c);
}
void chline(unsigned char c)
{
	while(c)
	{
		cputc('-');
		--c;
	}
}
void chlinexy(unsigned char x,unsigned char y,unsigned char c)
{
	gotoxy(x,y);
	chline(c);
}
void cclear(unsigned char c)
{
	while(c)
	{
		cputc(' ');
		--c;
	}
}
void cclearxy(unsigned char x,unsigned char y,unsigned char c)
{
	gotoxy(x,y);
	cclear(c);
}

void gotoxy(unsigned char x,unsigned char y)
{
	#ifdef USEANSI
    printf("%c[%d;%dH",27,y+1,x+1);
	#else
    printk("%c%c%c",22,32+(y),32+(x*2));
	#endif
	cx=x;cy=y;
}
unsigned char wherex(void)
{
	return(cx);
}
unsigned char wherey(void)
{
	return(cy);
}

unsigned char cursor(unsigned char col)
{
	col=col;
	return(0);
}

static unsigned char rvs_flag;

unsigned char revers(unsigned char col)
{
	unsigned char old;
	old=rvs_flag;

	if(col) rvs_flag=0x80;
	else rvs_flag=0;

	#ifdef USEANSI
	if(rvs_flag)
	{
  		printf ("%c[7m",27);
  	}
	else
	{
  		printf ("%c[27m",27);
  	}
	#else
	if(rvs_flag)
	{
		printk ("%c%c",20,32+1);
	}
	else
	{
		printk ("%c%c",20,32+0);
	}
	#endif

	if(old) return(1);
	return(0);
}
unsigned char textcolor(unsigned char col)
{
	//col=col;
	printk ("%c%c",16,32+col);
	return(1);
}
unsigned char bgcolor(unsigned char col)
{
	//col=col;
	printk ("%c%c",17,32+col);
	return(0);
}
unsigned char bordercolor(unsigned char col)
{
	col=col;
	return(0);
}

void screensize(unsigned char *x,unsigned char *y)
{
	*x=SCREENX;*y=SCREENY;
}
















