
///////////////////////////////////////////////////////////////////////////
// define some capabilities of the compiler
///////////////////////////////////////////////////////////////////////////

#if defined(__CC65__)
// use static locals for speed
#pragma staticlocals(1)
// alignment isnt terribly important here
#define __align8__
#define __align16__
#define __align32__

#elif defined(__SDCC__)
#define register
// alignment isnt terribly important here
#define __align8__
#define __align16__
#define __align32__
#define __fastcall__

#elif defined(__Z88DK__)
#define register
#define const
// alignment isnt terribly important here
#define __align8__
#define __align16__
#define __align32__
#define __fastcall__

#define NO2DIMARRAYS
#define NOGLOBALPTRINIT

#elif defined(__LCC__)
#define register
// alignment isnt terribly important here
// rant: we assume lcc is used for 8/16bit targets only mkay?
#define __align8__
#define __align16__
#define __align32__
#define __fastcall__

#elif defined(__GCC__)
/* gcc alignment macros */
#define __align8__   __attribute__ ((__aligned__(1)))
#define __align16__  __attribute__ ((__aligned__(2)))
#define __align32__  __attribute__ ((__aligned__(4)))
#define __fastcall__

#elif defined(__CODEWARRIOR__)
/* codewarrior alignment macros */
#define __align8__
#define __align16__
#define __align32__
#define __fastcall__

#endif	// compilers
 
